#include "colorbutton.h"

#include <QDrag>
#include <QMimeData>
#include <QPainter>

/* Color Button */

ColorButton::ColorButton (QString s)
  : name (s), color (QColor (s))
{
    setText (s);
    setToolTip (s);
    setIcon (createPixmap ());
}

void ColorButton::mousePressEvent(QMouseEvent *event)
{
    QDrag * drag = new QDrag (this);
    QMimeData * data = new QMimeData ();
    data->setText (name);
    data->setColorData (color);
    drag->setMimeData(data);
    drag->setPixmap (createPixmap (true));
    drag->start (Qt::CopyAction | Qt::MoveAction);
}

QPixmap ColorButton::createPixmap (bool white)
{
    QPixmap pixmap (24, 24);
    if (white)
       pixmap.fill (QColor (255, 255, 255, 255));
    else
       pixmap.fill (QColor (0, 0, 0, 0));

    QPainter painter (& pixmap);
    painter.setPen (color);
    painter.setBrush (color);
    painter.drawEllipse (2, 2, 20, 20);

    return pixmap;
};

